﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using FreshMvvm;
using MvvmHelpers;
using Syncfusion.SfRotator.XForms;
using Syncfusion.XForms.Buttons;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FreshMVVMSFDataGrid.ViewModel
{
    public class RotatorViewModel : ViewModelBase
    {

        #region Property WizardTemplates

        private ObservableRangeCollection<TemplateViewModelBase> _wizardTemplates = new ObservableRangeCollection<TemplateViewModelBase>();

        public ObservableRangeCollection<TemplateViewModelBase> WizardTemplates
        {
            get
            {
                return _wizardTemplates;
            }
            set
            {
                _wizardTemplates = value;
            }
        }

        #endregion

        #region Property WizardIndex

        private int _wizardIndex;

        public int WizardIndex
        {
            get
            {
                return _wizardIndex;
            }
            set
            {
                _wizardIndex = value;
            }
        }

        #endregion;

        #region Property SelectedIndexChangedCommand

        public Command SelectedIndexChangedCommand
        {
            get
            {
                return new Command(async (indexAsDouble) =>
                {
                    
                });
            }
        }

        #endregion
        
        public override async void Init(object initData)
        {
            base.Init(initData);
            
            MessagingCenter.Subscribe<RotatorPage1ViewModel>(this, "InsertPageClicked",
                async (sender) =>
                {
                    InsertPage();
                });

            List<TemplateViewModelBase> templates = new List<TemplateViewModelBase>();

            RotatorPage1ViewModel page1 = new RotatorPage1ViewModel
            {
                Name = "Page 1",
                Description = "Page 1 Description",
                PageNumber = 1,
                BackgroundColor = "Red"
            };
            templates.Add(page1);

            RotatorPage2ViewModel page2 = new RotatorPage2ViewModel
            {
                Choice1 = "Option 1",
                Choice2 = "Option 2",
                Choice3 = "Option 3",
                Choice4 = "Option 4",
                BackgroundColor = "Blue"
            };
            templates.Add(page2);

            RotatorPage3ViewModel page3 = new RotatorPage3ViewModel
            {
                ButtonText1 = "Button 1",
                ButtonText2 = "Button 2",
                ButtonText3 = "Button 3",
                ButtonText4 = "Button 4",
                BackgroundColor = "Yellow"
            };
            templates.Add(page3);

            _wizardTemplates.ReplaceRange(templates);
            
        }

        private void InsertPage()
        {
            //foreach (TemplateViewModelBase template in _wizardTemplates)
            //{
            //    template.Template = null;
            //}

            //RotatorPage1ViewModel rotatorPage1ViewModel = (RotatorPage1ViewModel) _wizardTemplates[0];
            //ScrollView scrollView = (ScrollView) rotatorPage1ViewModel.Template.Children[0];
            //StackLayout stackLayout = (StackLayout)scrollView.Children[0];
            //StackLayout stackLayout2 = (StackLayout)stackLayout.Children[5];
            //SfCheckBox checkBox = (SfCheckBox)stackLayout2.Children[2];
            //Xamarin.Forms.Behavior behavior = checkBox.Behaviors[0];
            //checkBox.Behaviors.Remove(behavior);

            
            List<TemplateViewModelBase> templates = new List<TemplateViewModelBase>();
            templates = _wizardTemplates.ToList(); //Take a copy of existing templates.

            //_wizardTemplates = null;
            //GC.Collect();
            //_wizardTemplates = new ObservableRangeCollection<TemplateViewModelBase>();


            RotatorPage3ViewModel page4 = new RotatorPage3ViewModel //Create a new one.
            {
                ButtonText1 = "Button 1",
                ButtonText2 = "Button 2",
                ButtonText3 = "Button 3",
                ButtonText4 = "Button 4",
                BackgroundColor = "Green"
            };

            templates.Insert(WizardIndex + 1, page4); //Insert into position 2

            _wizardTemplates.ReplaceRange(templates); //Clear and replace templates.
            WizardIndex++; //Go to second page.
        }
    }
}